

require "defines"

-- Keyport inputs: S is stop. Others are directional inputs that can toggle walking.
-- QWE
-- ASD
-- ZXC
local old
local directions = { w = defines.direction.north,
  e = defines.direction.northeast,
  d = defines.direction.east,
  c = defines.direction.southeast,
  x = defines.direction.south,
  z = defines.direction.southwest,
  a = defines.direction.west,
  q = defines.direction.northwest
}

function getInput()
  local input = game.player.gui.left["remote-move"].text:sub(-1)
  game.player.gui.left["remote-move"].text = ""
  return input
end

local function initGUI()
	if not game.player.gui.left["remote-move"] then
		field = game.player.gui.left.add{ type="textfield", name="remote-move", text = "Click me."  }
	end
end

local function toggleMoving(state)
  if type(state) == "boolean" then
    glob.char.walkingstate = { walking = state, direction = glob.char.walkingstate.direction }
  elseif state == nil then
    glob.char.walkingstate = { walking = not glob.char.walkingstate.walking,
                               direction = glob.char.walkingstate.direction }
  else
	  glob.char.walkingstate = { walking = true, direction = state }
  end
end

local function ontick(event)
  local new = getInput()
  if new == old then
    toggleMoving()
  elseif new == "s" then
    toggleMoving(false)
  elseif directions[new] then
    toggleMoving(directions[new])
  end
  old = directions[new] and new or old
end



game.oninit(function()
	initGUI()
end)

game.onload(function()
	initGUI()
end)

game.onsave(function()

end)

game.onevent(defines.events.onguiclick, function(event)
	if (event.element.name == "remote-move") then
    if not glob.char then
      glob.char = game.player.character
      game.player.character = nil
      event.element.text = ""
      game.onevent(defines.events.ontick, ontick)
    else
      game.player.character = glob.char
      glob.char = nil
      event.element.text = "Click me."
      game.onevent(defines.events.ontick, nil)
    end
	end
end)